#include "emac.h"
#include "regs.h"

void EMAC_Init() /* minimal init just for TX */
{
	int k;

	PMC_PCER = (1 << PERIPH_ID_EMAC) 
	         | (1 << PERIPH_ID_PIOA)
				| (1 << PERIPH_ID_PIOB);

/* Port B lines to be pulled low during PHY power up (switch pull-ups off) */
#define PHYADD_SET_LO ((1 << 5) | (1 << 6) | (1 << 13) | (1 << 14))
/* Port B line ro be pulled high during PHY power up (pull-up on) */
#define PHYADD_SET_HI (1 << 26)
/* Port B line used to switch PHY power */
#define PHY_PD (1 << 18)


	PIOB_PDR  = 0x0003ffff; /* disable PIO on pins used for EMAC */
	PIOB_ASR  = 0x0003ffff; /* select peripheral A (the EMAC) for these pins */
	PIOB_IDR  = 0x0003ffff | PHY_PD; /* disable interrupts on all pins used */

	PIOB_CODR = PHY_PD;     /* power down the PHY */
	PIOB_PER  = PHY_PD;
	PIOB_OER  = PHY_PD;

	PIOB_PUDR = PHYADD_SET_LO; /* setup pull-ups to latch PYH address 0x01 */
	PIOB_PUER = PHYADD_SET_HI;

	for(k = 0; k < 50000; k++) /* delay 10 ms by reading status many times */
		PIOB_PDSR;

	PIOB_SODR = PHY_PD;     /* power up the PHY */	

	EMAC_NCR = 0;
	EMAC_IDR = 0xffffffff;
	EMAC_NCFGR = EMAC_NCFGR_SPD | EMAC_NCFGR_FD | EMAC_NCFGR_NBC
	           | (2 * EMAC_NCFGR_CLK)
				  | EMAC_NCFGR_PAE | EMAC_NCFGR_DRFCS; 
	EMAC_NCR = EMAC_NCR_MPE | EMAC_NCR_TE;
	EMAC_USRIO = EMAC_USRIO_CLKEN;
}

void EMAC_Send(struct EMAC_TX_BDT_Entry *tx_bdt)
{
	while( EMAC_TSR & EMAC_TSR_TGO )
		;
	EMAC_TBQP = (unsigned int)tx_bdt;
	EMAC_NCR |= EMAC_NCR_TSTART;
}
