#define REG(X) (*(volatile unsigned int *)(X))

/* Debug USART */
#define DBGU       0xFFFFF200
#define DBGU_CR    REG(DBGU + 0x0000)
#define DBGU_MR    REG(DBGU + 0x0004)
#define DBGU_IER   REG(DBGU + 0x0008)
#define DBGU_IDR   REG(DBGU + 0x000C)
#define DBGU_IMR   REG(DBGU + 0x0010)
#define DBGU_SR    REG(DBGU + 0x0014)
#define DBGU_RHR   REG(DBGU + 0x0018)
#define DBGU_THR   REG(DBGU + 0x001C)
#define DBGU_BRGR  REG(DBGU + 0x0020)
#define DBGU_CIDR  REG(DBGU + 0x0040)
#define DBGU_EXID  REG(DBGU + 0x0044)
#define DBGU_FNR   REG(DBGU + 0x0048)

#define DBGU_SR_RXRDY (1 << 0)
#define DBGU_SR_TXRDY (1 << 1)

/* Ethernet Controller */
#define EMAC       0xFFFDC000
#define EMAC_NCR   REG(EMAC + 0x00)
#define EMAC_NCFGR REG(EMAC + 0x04)
#define EMAC_NSR   REG(EMAC + 0x08)
#define EMAC_TSR   REG(EMAC + 0x14)
#define EMAC_RBQP  REG(EMAC + 0x18)
#define EMAC_TBQP  REG(EMAC + 0x1C)
#define EMAC_RSR   REG(EMAC + 0x20)
#define EMAC_ISR   REG(EMAC + 0x24)
#define EMAC_IER   REG(EMAC + 0x28)
#define EMAC_IDR   REG(EMAC + 0x2C)
#define EMAC_IMR   REG(EMAC + 0x30)
#define EMAC_MAN   REG(EMAC + 0x34)
#define EMAC_PTR   REG(EMAC + 0x38)
#define EMAC_PFR   REG(EMAC + 0x3C)
#define EMAC_FTO   REG(EMAC + 0x40)
#define EMAC_SCF   REG(EMAC + 0x44)
#define EMAC_MCF   REG(EMAC + 0x48)
#define EMAC_FRO   REG(EMAC + 0x4C)
#define EMAC_FCSE  REG(EMAC + 0x50)
#define EMAC_ALE   REG(EMAC + 0x54)
#define EMAC_DTF   REG(EMAC + 0x58)
#define EMAC_LCOL  REG(EMAC + 0x5C)
#define EMAC_ECOL  REG(EMAC + 0x60)
#define EMAC_TUND  REG(EMAC + 0x64)
#define EMAC_CSE   REG(EMAC + 0x68)
#define EMAC_RRE   REG(EMAC + 0x6C)
#define EMAC_ROV   REG(EMAC + 0x70)
#define EMAC_RSE   REG(EMAC + 0x74)
#define EMAC_ELE   REG(EMAC + 0x78)
#define EMAC_RJA   REG(EMAC + 0x7C)
#define EMAC_USF   REG(EMAC + 0x80)
#define EMAC_STE   REG(EMAC + 0x84)
#define EMAC_RLE   REG(EMAC + 0x88)
#define EMAC_HRB   REG(EMAC + 0x90)
#define EMAC_HRT   REG(EMAC + 0x94)
#define EMAC_SA1B  REG(EMAC + 0x98)
#define EMAC_SA1T  REG(EMAC + 0x9C)
#define EMAC_SA2B  REG(EMAC + 0xA0)
#define EMAC_SA2T  REG(EMAC + 0xA4)
#define EMAC_SA3B  REG(EMAC + 0xA8)
#define EMAC_SA3T  REG(EMAC + 0xAC)
#define EMAC_SA4B  REG(EMAC + 0xB0)
#define EMAC_SA4T  REG(EMAC + 0xB4)
#define EMAC_TID   REG(EMAC + 0xB8)
#define EMAC_USRIO REG(EMAC + 0xC0)

#define EMAC_RSR_OVR     (1 << 2)
#define EMAC_RSR_REC     (1 << 1)
#define EMAC_RSR_BNA     (1 << 0)

#define EMAC_TSR_UND     (1 << 6)
#define EMAC_TSR_COMP    (1 << 5)
#define EMAC_TSR_BEX     (1 << 4)
#define EMAC_TSR_TGO     (1 << 3)
#define EMAC_TSR_RLE     (1 << 2)
#define EMAC_TSR_COL     (1 << 1)
#define EMAC_TSR_UBR     (1 << 0)

#define EMAC_NCFGR_IRXFCS (1 << 19)
#define EMAC_NCFGR_EFRHD  (1 << 18)
#define EMAC_NCFGR_DRFCS  (1 << 17)
#define EMAC_NCFGR_RLCE   (1 << 16)
#define EMAC_NCFGR_RBOF   (1 << 14)
#define EMAC_NCFGR_PAE    (1 << 13)
#define EMAC_NCFGR_RTY    (1 << 12)
#define EMAC_NCFGR_CLK    (1 << 10)
#define EMAC_NCFGR_BIG    (1 <<  8)
#define EMAC_NCFGR_UNI    (1 <<  7)
#define EMAC_NCFGR_MTI    (1 <<  6)
#define EMAC_NCFGR_NBC    (1 <<  5)
#define EMAC_NCFGR_CAF    (1 <<  4)
#define EMAC_NCFGR_JFRAME (1 <<  3)
#define EMAC_NCFGR_FD     (1 <<  1)
#define EMAC_NCFGR_SPD    (1 <<  0)

#define EMAC_NCR_THALT    (1 << 10)
#define EMAC_NCR_TSTART   (1 <<  9)
#define EMAC_NCR_BP       (1 <<  8)
#define EMAC_NCR_WESTAT   (1 <<  7)
#define EMAC_NCR_INCSTAT  (1 <<  6)
#define EMAC_NCR_CLRSTAT  (1 <<  5)
#define EMAC_NCR_MPE      (1 <<  4)
#define EMAC_NCR_TE       (1 <<  3)
#define EMAC_NCR_RE       (1 <<  2)
#define EMAC_NCR_LLB      (1 <<  1)
#define EMAC_NCR_LB       (1 <<  0)

#define EMAC_NSR_IDLE  (1 << 2)
#define EMAC_NSR_MDIO  (1 << 1)

#define EMAC_MAN_SOF_AND_CODE ((1 << 30) | (2 << 16))
#define EMAC_MAN_READ  (EMAC_MAN_SOF_AND_CODE | (2 << 28))
#define EMAC_MAN_WRITE (EMAC_MAN_SOF_AND_CODE | (1 << 28))
#define EMAC_MAN_PHYA  (1 << 23)
#define EMAC_MAN_REGA  (1 << 18)

#define EMAC_USRIO_CLKEN (1 << 1)
#define EMAC_USRIO_RMII  (1 << 0)

/* Power Management Controller */
#define PMC        0xFFFFFC00
#define CKGR       PMC
#define PMC_SCER   REG(PMC + 0x0000)
#define PMC_SCDR   REG(PMC + 0x0004)
#define PMC_SCSR   REG(PMC + 0x0008)
#define PMC_PCER   REG(PMC + 0x0010)
#define PMC_PCDR   REG(PMC + 0x0014)
#define PMC_PCSR   REG(PMC + 0x0018)
#define PMC_MCKR   REG(PMC + 0x0030)
#define PMC_PCK0   REG(PMC + 0x0040)
#define PMC_PCK1   REG(PMC + 0x0044)
#define PMC_IER    REG(PMC + 0x0060)
#define PMC_IDR    REG(PMC + 0x0064)
#define PMC_SR     REG(PMC + 0x0068)
#define PMC_IMR    REG(PMC + 0x006C)
#define CKGR_MOR   REG(CKGR + 0x0020)
#define CKGR_MCFR  REG(CKGR + 0x0024)
#define CKGR_PLLR  REG(CKGR + 0x002C)

#define PMC_SR_MCKRDY (1 << 3)
#define PMC_SR_LOCK   (1 << 2)
#define PMC_SR_MOSCS  (1 << 0)

#define CKGR_MOR_OSCOUNT   (1 << 8)
#define CKGR_MOR_OSCBYPASS (1 << 1)
#define CKGR_MOR_MOSCEN    (1 << 0)

/* Peripheral IDs */
#define PERIPH_ID_AIC	0
#define PERIPH_ID_SYSC	1
#define PERIPH_ID_PIOA	2
#define PERIPH_ID_PIOB	3
#define PERIPH_ID_SPI0	4
#define PERIPH_ID_SPI1	5
#define PERIPH_ID_US0	6
#define PERIPH_ID_US1	7
#define PERIPH_ID_SSC	8
#define PERIPH_ID_TWI	9
#define PERIPH_ID_PWMC	10
#define PERIPH_ID_UDP	11
#define PERIPH_ID_TC0	12
#define PERIPH_ID_TC1	13
#define PERIPH_ID_TC2	14
#define PERIPH_ID_CAN	15
#define PERIPH_ID_EMAC	16
#define PERIPH_ID_ADC	17
#define PERIPH_ID_AIC0	30
#define PERIPH_ID_AIC1	31

/* Embedded Flash Controller (EFC) */
#define MC         0xffffff00
#define MC_FMR     REG(MC + 0x60)
#define MC_FCR     REG(MC + 0x64)
#define MC_FSR     REG(MC + 0x68)

#define MC_FMR_FMCN  (1 << 16)
#define MC_FMR_FWS   (1 <<  8)
#define MC_FMR_NEBP  (1 <<  7)
#define MC_FMR_PROGE (1 <<  3)
#define MC_FMR_LOCKE (1 <<  2)
#define MC_FMR_FRDY  (1 <<  0)

#define MC_FCR_KEY 0x5a000000
#define MC_FCR_PAGEN (1 << 8)

#define MC_FSR_FRDY  (1 << 0)

#define FCMD_None 0
#define FCMD_WP   1 /* write page */
#define FCMD_SLB  2 /* set lock bit */
#define FCMD_WPL  3 /* write page and lock */
#define FCMD_CLB  4 /* clear lock bit */
#define FCMD_EA   8 /* erase all */
#define FCMD_SGPB 0x0b /* set General Purpose NVM Bit */
#define FCMD_CGPB 0x0d /* clear General Purpose NVM Bit */
#define FCMD_SSB  0x0f /* set Security Bit */

#define FLASH_BASE 0x00100000
#define FLASH_PAGESIZE 0x100

/* Peripheral IO */
#define PIOA        0xfffff400
#define PIOA_PER    REG(PIOA + 0x0000)
#define PIOA_PDR    REG(PIOA + 0x0004)
#define PIOA_PSR    REG(PIOA + 0x0008)
#define PIOA_OER    REG(PIOA + 0x0010)
#define PIOA_ODR    REG(PIOA + 0x0014)
#define PIOA_OSR    REG(PIOA + 0x0018)
#define PIOA_IFER   REG(PIOA + 0x0020)
#define PIOA_IFDR   REG(PIOA + 0x0024)
#define PIOA_IFSR   REG(PIOA + 0x0028)
#define PIOA_SODR   REG(PIOA + 0x0030)
#define PIOA_CODR   REG(PIOA + 0x0034)
#define PIOA_ODSR   REG(PIOA + 0x0038)
#define PIOA_PDSR   REG(PIOA + 0x003C)
#define PIOA_IER    REG(PIOA + 0x0040)
#define PIOA_IDR    REG(PIOA + 0x0044)
#define PIOA_IMR    REG(PIOA + 0x0048)
#define PIOA_MDER   REG(PIOA + 0x0050)
#define PIOA_MDDR   REG(PIOA + 0x0054)
#define PIOA_MDSR   REG(PIOA + 0x0058)
#define PIOA_PUDR   REG(PIOA + 0x0060)
#define PIOA_PUER   REG(PIOA + 0x0064)
#define PIOA_PUSR   REG(PIOA + 0x0068)
#define PIOA_ASR    REG(PIOA + 0x0070)
#define PIOA_ABSR   REG(PIOA + 0x0078)
#define PIOA_OWER   REG(PIOA + 0x00A0)
#define PIOA_OWDR   REG(PIOA + 0x00A4)
#define PIOA_OWSR   REG(PIOA + 0x00A8)

#define PIOB        0xfffff600
#define PIOB_PER    REG(PIOB + 0x0000)
#define PIOB_PDR    REG(PIOB + 0x0004)
#define PIOB_PSR    REG(PIOB + 0x0008)
#define PIOB_OER    REG(PIOB + 0x0010)
#define PIOB_ODR    REG(PIOB + 0x0014)
#define PIOB_OSR    REG(PIOB + 0x0018)
#define PIOB_IFER   REG(PIOB + 0x0020)
#define PIOB_IFDR   REG(PIOB + 0x0024)
#define PIOB_IFSR   REG(PIOB + 0x0028)
#define PIOB_SODR   REG(PIOB + 0x0030)
#define PIOB_CODR   REG(PIOB + 0x0034)
#define PIOB_ODSR   REG(PIOB + 0x0038)
#define PIOB_PDSR   REG(PIOB + 0x003C)
#define PIOB_IER    REG(PIOB + 0x0040)
#define PIOB_IDR    REG(PIOB + 0x0044)
#define PIOB_IMR    REG(PIOB + 0x0048)
#define PIOB_MDER   REG(PIOB + 0x0050)
#define PIOB_MDDR   REG(PIOB + 0x0054)
#define PIOB_MDSR   REG(PIOB + 0x0058)
#define PIOB_PUDR   REG(PIOB + 0x0060)
#define PIOB_PUER   REG(PIOB + 0x0064)
#define PIOB_PUSR   REG(PIOB + 0x0068)
#define PIOB_ASR    REG(PIOB + 0x0070)
#define PIOB_ABSR   REG(PIOB + 0x0078)
#define PIOB_OWER   REG(PIOB + 0x00A0)
#define PIOB_OWDR   REG(PIOB + 0x00A4)
#define PIOB_OWSR   REG(PIOB + 0x00A8)

/* Synchronous Serial Controller */
#define SSC        0xfffd4000
#define SSC_CR     REG(SSC + 0x0)
#define SSC_CMR    REG(SSC + 0x4)
#define SSC_RCMR   REG(SSC + 0x10)
#define SSC_RFMR   REG(SSC + 0x14)
#define SSC_TCMR   REG(SSC + 0x18)
#define SSC_TFMR   REG(SSC + 0x1C)
#define SSC_RHR    REG(SSC + 0x20)
#define SSC_THR    REG(SSC + 0x24)
#define SSC_RSHR   REG(SSC + 0x30)
#define SSC_TSHR   REG(SSC + 0x34)
#define SSC_RC0R   REG(SSC + 0x38)
#define SSC_RC1R   REG(SSC + 0x3C)
#define SSC_SR     REG(SSC + 0x40)
#define SSC_IER    REG(SSC + 0x44)
#define SSC_IDR    REG(SSC + 0x48)
#define SSC_IMR    REG(SSC + 0x4C)

#define SSC_CR_SWRST (1 << 15)
#define SSC_CR_TXDIS (1 <<  9)
#define SSC_CR_TXEN  (1 <<  8)
#define SSC_CR_RXDIS (1 <<  1)
#define SSC_CR_RXEN  (1 <<  0)

#define SSC_RCMR_PERIOD (1 << 24)
#define SSC_RCMR_STDDLY (1 << 16)
#define SSC_RCMR_STOP   (1 << 12)
#define SSC_RCMR_START  (1 <<  8)
#define SSC_RCMR_CKG    (1 <<  6)
#define SSC_RCMR_CKI    (1 <<  5)
#define SSC_RCMR_CKO    (1 <<  2)
#define SSC_RCMR_CKS    (1 <<  0)

#define SSC_RFMR_FSEDGE (1 << 24)
#define SSC_RFMR_FSOS   (1 << 20)
#define SSC_RFMR_FSLEN  (1 << 16)
#define SSC_RFMR_DATNB  (1 <<  8)
#define SSC_RFMR_MSBF   (1 <<  7)
#define SSC_RFMR_LOOP   (1 <<  5)
#define SSC_RFMR_DATLEN (1 <<  0)

/* Peripheral DMA Controller */
#define PDC_RPR(PERIPH)  REG(PERIPH + 0x100)
#define PDC_RCR(PERIPH)  REG(PERIPH + 0x104)
#define PDC_TPR(PERIPH)  REG(PERIPH + 0x108)
#define PDC_TCR(PERIPH)  REG(PERIPH + 0x10C)
#define PDC_RNPR(PERIPH) REG(PERIPH + 0x110)
#define PDC_RNCR(PERIPH) REG(PERIPH + 0x114)
#define PDC_TNPR(PERIPH) REG(PERIPH + 0x118)
#define PDC_TNCR(PERIPH) REG(PERIPH + 0x11C)
#define PDC_PTCR(PERIPH) REG(PERIPH + 0x120)
#define PDC_PTSR(PERIPH) REG(PERIPH + 0x124)

#define PDC_PTCR_TXTDIS (1 << 9)
#define PDC_PTCR_TXTEN  (1 << 8)
#define PDC_PTCR_RXTDIS (1 << 1)
#define PDC_PTCR_RXTEN  (1 << 0)

/* Watchdog */
#define WDT        0xfffffd40
#define WDT_CR     REG(WDT + 0x00)
#define WDT_MR     REG(WDT + 0x04)
#define WDT_SR     REG(WDT + 0x08)

#define WDT_MR_WDDIS (1 << 15)
/* EOF */
