#include "ssc.h"
#include "regs.h"

void SSC_Init() /* configure SSC for continuous reveive */
{
	PMC_PCER = (1 << PERIPH_ID_SSC);  /* enable peripheral clock for SSC */
	PIOA_PDR = (1 << 24);             /* disable PIO on PA24 */
	PIOA_ASR = (1 << 24);             /* PA24, peripheral A is RD */
	PIOA_PUDR = (1 << 24);            /* PA24 pull-up off */

	SSC_CR  = SSC_CR_SWRST; /* reset the SSC */
	SSC_CMR = 1;            /* fastest possible clock: (half MCK) / 1 */
	SSC_RCMR = 0;           /* continuous RX clock etc. */
	SSC_RFMR = (32 - 1) * SSC_RFMR_DATLEN + (16 - 1) * SSC_RFMR_DATNB;
	SSC_CR = SSC_CR_RXEN;   /* enable RX */
}
