#include "udpip.h"
#include "emac.h"
#define NULL 0

struct packet_head
{
	unsigned char mac_dst[6];
	unsigned char mac_src[6];
	unsigned short mac_type;

	unsigned char ip_vihl;
	unsigned char ip_tos;
	unsigned short ip_len;
	unsigned short ip_id;
	unsigned short ip_flags;
	unsigned char ip_ttl;
	unsigned char ip_prot;
	unsigned short ip_check;
	unsigned char ip_src[4];
	unsigned char ip_dst[4];
	/*unsigned char ip_opt[3];
	unsigned char ip_pad;*/

	unsigned short udp_src;
	unsigned short udp_dst;
	unsigned short udp_len;
	unsigned short udp_check;
	unsigned char filler[2];
} head[2];

unsigned int idx;

#define htons(S) (((S) >> 8) | ((0xFF & (S)) << 8))
#define htonl(L) (((L) >> 24) | (((L) >> 8) & 0xFF00) \
               | (((L) << 8) & 0xFF0000) | ((L) << 24))
#define ntohs(S) htons(S)
#define ntohl(L) htonl(L)

void UDPIP_Init()
{
	int k;

	for(idx = 0; idx < 2; idx++)
	{
		for(k = 0; k < 6; k++)
		{
			head[idx].mac_src[k] = 0x22 * k + 0x12;
			head[idx].mac_dst[k] = 0xff;
		}
		head[idx].mac_type = htons(0x0800);

		head[idx].ip_vihl = 0x45;
		head[idx].ip_tos = 0x00;
		head[idx].ip_len = 0;
		head[idx].ip_id = htons(idx);
		head[idx].ip_flags = 0;
		head[idx].ip_ttl = 64;
		head[idx].ip_prot = 17; /* UDP */
		head[idx].ip_check = 0;
		head[idx].udp_src = htons(0x600);
		head[idx].udp_dst = htons(0x600);
		head[idx].udp_check = 0;

		for(k = 0; k < 4; k++)
		{
			head[idx].ip_dst[k] = 0xff;
			head[idx].ip_src[k] = "\xc0\xa8\x00\x99"[k];
		}	
	}
	idx = 0;
}

void IP_Set_Checksum(struct packet_head *head)
{
	unsigned int k, csum;
	unsigned short *s;

	s = (unsigned short *)&head->ip_vihl;
	head->ip_check = 0;
	csum = 0;
	for(k = 0; k < 10; k++)
		csum += s[k]; /* no need to worry about endianness here */
	head->ip_check = (csum % 0xffff) ^ 0xffff;
}

struct EMAC_TX_BDT_Entry tx_bdt[3];

void UDPIP_Send(unsigned char *data, unsigned int len)
{
	head[idx].ip_id = htons(ntohs(head[idx].ip_id) + 2);
	head[idx].ip_len = htons(28 + len);
	head[idx].udp_len = htons(8 + len);

	IP_Set_Checksum(&head[idx]);

	tx_bdt[0].data = (unsigned char *)&head[idx];
	tx_bdt[0].flags = sizeof(struct packet_head) - sizeof(head[0].filler);
	tx_bdt[1].data = data;
	tx_bdt[1].flags = len | EMAC_TX_BDT_Last;
	tx_bdt[2].data = NULL;
	tx_bdt[2].flags = EMAC_TX_BDT_Wrap; /* EMAC may write back status here */

	idx = (idx + 1) % 2;

	EMAC_Send(tx_bdt);
}
